<?xml version="1.0" encoding="UTF-8" ?>
<schema xmlns="http://www.ascc.net/xml/schematron">
    <ns uri="http://amis.nl/schematrondemo/company" prefix="cmp" />
    <ns uri="http://amis.nl/schematrondemo/common" prefix="com" />
    <pattern name="Managers earn more than normal employees">
        <rule context="//cmp:Department[@name!='Managers']/cmp:Employees/com:Employee">
            <assert test="com:Salary &lt; min(//cmp:Department[@name='Managers']/cmp:Employees/com:Employee/com:Salary)">Employee earns too much</assert>
        </rule>
    </pattern>
    <pattern name="Employee may not be the manager of himself">
        <rule context="//com:Employee[@manager_id]">
            <assert test="@manager_id != @id">Employee may not manage himself</assert>
        </rule>
    </pattern>
    <pattern name="All normal employees have a manager">
        <rule context="//cmp:Company/cmp:Department[@name!='Managers']/cmp:Employees/com:Employee">
            <assert test="@manager_id">Employee must have a manager</assert>
        </rule>
    </pattern>
    <pattern name="Only one manager without manager, the president">
        <rule context="//cmp:Company/cmp:Department[@name='Managers']/cmp:Employees">
            <assert test="count(com:Employee[not(@manager_id)]) = 1">There must be exactly one president</assert>
        </rule>
    </pattern>
    <pattern name="Manager doens not exist">
        <rule context="//com:Employee[@manager_id]">
            <assert test="//cmp:Company/cmp:Department[@name='Managers']/cmp:Employees/com:Employee[@id=current()/@manager_id]">No valid manager</assert>
        </rule>
    </pattern>
</schema>